<?php
function ex2(){
	if (substr(PHP_VERSION,0,1) < 5){
		echo "Highlighting does not work on this server!";
	}else{
		$gesh = true;
		include_once('../geshi/geshi.php');
		$gpath='../geshi/geshi';
	}

?>
		<h3>Example2 with screenshots</h3>

		<b>Step1:</b>
		<div style="margin-left:15px;">
		
			Script that emits the tuple <code>(1,1min-load,5min-load,15min-load)</code> for each server it is run on:
			<div style="margin-left:15px;">
				
<?php
				$s = "#!/usr/bin/php -f
<?php
        \$u = `uptime`;
        \$load = trim(substr(\$u,strrpos(\$u,':')+1));
        \$vals = explode( (strpos(\$load,',')>0)?',':' ',\$load);
        printf('(1,%s,%s,%s)',\$vals[0],\$vals[1],\$vals[2]);
?>";
    			if ($gesh) geshi_highlight($s, 'php', $gpath);
?>
			</div>
			It just runs `uptime`, gets the rest of the output after the ':'
			and splits the numbers of at either ',' or ' ', depending on which is there.
			Then it emits the tuple to <code>stdout</code>.<br />
			It needs to be executable and thus has an appropriate shebang.
			
		</div>
		<br />
		<b>Step2:</b>
		<div style="margin-left:15px;">
			In addition to the Init script we now write an aggregator and evaluator.
			The aggregator looks like this:
			<div style="margin-left:15px;">
				
<?php
				$s = "#!/usr/bin/php -f
<?php
        fscanf(STDIN, \"%d\\n\", \$l1);
        \$first = fread(STDIN,\$l1);
        fread(STDIN,1);
        fscanf(STDIN, \"%d\\n\", \$l2);
        \$second = fread(STDIN,\$l2);
        \$v1 = explode(',',substr(\$first,1,strlen(\$first)-2));
        \$v2 = explode(',',substr(\$second,1,strlen(\$second)-2));
        printf(\"(%u,%f,%f,%f)\",
                        (round(\$v1[0]+\$v2[0])),
                        (\$v1[1]+\$v2[1]),
                        (\$v1[2]+\$v2[2]),
                        (\$v1[3]+\$v2[3])
        );
?>";
    			if ($gesh) geshi_highlight($s, 'php', $gpath);
?>
			</div>
			This script takes two runs from Init on <code>stdin</code>, reads them into <code>$first</code> and <code>$second</code>
			,splits the two parentheses of and splits them on ','.
			It then adds all values up and emits a new tuple.
		</div>
		
		<br />
		<b>Step3:</b>
		<div style="margin-left:15px;">
			The evaluator looks like this:
			<div style="margin-left:15px;">
				
<?php
				$s = "#!/usr/bin/php -f
<?php
        \$in = trim(stream_get_contents(STDIN));
        \$v = explode(',',substr(\$in,1,strlen(\$in)-2));
        printf(\"(%.4f,%.4f,%.4f)\",
                        (\$v[1]/\$v[0]),
                        (\$v[2]/\$v[0]),
                        (\$v[3]/\$v[0])
        );
?>
";
    			if ($gesh) geshi_highlight($s, 'php', $gpath);
?>
			</div>
			This script takes the output of the last reduce run on <code>stdin</code>,
			splits the two parentheses of and splits them on ','.
			It then divides all fields by the first number and prints the output to <code>stdout</code>.
		</div>
		
		<br />

		<b>Step4:</b>
		<div style="margin-left:15px;">
			<img src="img/plmr1-IPs.png" style="float:right;" />
			After starting PLMR select a file with a list of IPs in the first tab, enter
			the username and a name for the run:
			<br style="clear:both;" />
		</div>
		<br />
		<b>Step5:</b>
		<div style="margin-left:15px;">
			Select the Map script from step1 in the tab, and the others in the appropiate tabs.
			<br style="clear:both;" />
		</div>
		<br />
		<b>Step6:</b>
		<div style="margin-left:15px;">
			Back in the IPs tab hit Run!
		</div>
		<br />
		<b>Step7:</b>
		<div style="margin-left:15px;">
			<img src="img/plmr2a-Res-plain.png" style="float:right;" />
			After the ProgressBar has stopped moving, go to the Results tab and take a look at the results.
			<br />
			Note that the 1 in the first place is gone and the values look rounded.
			<br style="clear:both;" />
			
		</div>
		
<?php
}
?>