<?php
function ex4(){
	if (substr(PHP_VERSION,0,1) < 5){
		echo "Highlighting does not work on this server!";
	}else{
		$gesh = true;
		include_once('../geshi/geshi.php');
		$gpath='../geshi/geshi';
	}
?>
		<h3>Example4 with screenshots</h3>
				
			I wanted to be able to plot servers based on their coords in a XYZ-Plot with the Z-val supplying some useful info.
			In other words I needed a way of getting the coordinates on a running PL slice.
			Since I found no way for doing that I had to come up with my own, that is getting and parsing
			sites.xml.<br>
			It is located on our server and just returns a (long,lat) tuple when confronted with a hostname.<br />
			<a href="allsites-highlighter.php?f=1">This</a> is its source.<br />
			The Map script makes use of that.
			<br />
			<br />
						
		<b>Step1:</b>
		<div style="margin-left:15px;">
		
			Script that emits the tuple <code>(&lt;lon&gt;,&lt;lat&gt;,&lt;1min-load&gt;)</code> for each server it is run on:
			<div style="margin-left:15px;">
				
<?php
				$s = "#!/usr/bin/php -f
<?php
        \$req_str = 'http://dlab.robust.cs.utep.edu/~vitus/plmr/allsites.php?hostname=';
        \$u = `uptime`;
        \$h = trim(`hostname`);
        //split load
        \$load = trim(substr(\$u,strrpos(\$u,':')+1));
        \$vals = explode( (strpos(\$load,',')>0)?',':' ',\$load);
        //and get coords
        \$c = file_get_contents(\$req_str . \$h);
        \$c = substr(\$c,1,strlen(\$c)-2);
        printf(\"(%s,%s)\",\$c,\$vals[0]);
?>
";
    			if ($gesh) geshi_highlight($s, 'php', $gpath);
?>
			</div>
			It just runs `uptime`, gets the rest of the output after the ':'
			and splits the numbers of at either ',' or ' ', depending on which is there.
			It runs `hostname` to get the hostname.
			Then it requests the contents of the web-address of the script on the server which is a <code>(lon,lat)</code> tuple.
			Then it emits the tuple to <code>stdout</code>.<br />
			
		</div>
		<br />
		<b>Step2/3:</b>
		<div style="margin-left:15px;">
			We do not want any aggregation or evaluation, so we don't specify neither
			aggregator nor evaluator.
		</div>
		<br />
		<b>Step4:</b>
		<div style="margin-left:15px;">
			Select a list of IPs in the IPs tab.
		</div>
		<br />
		<b>Step5:</b>
		<div style="margin-left:15px;">
			<img src="img/plmr2-Init.png" style="float:right;" />
			Select the Map script from step1 in the tab:
			<br style="clear:both;" />
		</div>
		<br />
		<b>Step6/7:</b>
		<div style="margin-left:15px;">
			<img src="img/plmr2-Res-plain.png" style="float:right;" />
			No Aggregator and evaluator are selected, so after hitting "Run!" and waiting for its completion,
			the plain result is this:<br />
			(Note (-106,31) is UTEP, the other two are in Z&uuml;rich and Italy)
			<br style="clear:both;" />
			<br />

			<img src="img/plmr2-Res-bubble.png" style="float:right;" />
			The bubble (diameter) XYZ Plot look like this:
			<br style="clear:both;" />
			<br />

			<img src="img/plmr2-Res-color.png" style="float:right;" />
			And the color XYZ Plot like this:<br>
			The colors are chosen based on the range of the current domain (that is the spread of all points to be drawn)
			with the lowest value drawn in green and the highest in red, and the others in between (orange-yellow):
			<br style="clear:both;" />
			<br />

			<img src="img/plmr2-Res-world-bubble.png" style="float:right;" />
			Using the Chart Preferences you can set the ranges of the X and Y Axis to their right values for a 2d representation of the world
			([-180,180] and [-90,90] respectively) and chose a nice background image of the world (I also changed the captions a little
			to be more descriptive :), it will look like this with bubbles:
			(Note: the two European servers are hardly noticable, because of their size):
			<br style="clear:both;" />
			<br />

			<img src="img/plmr2-Res-world-color.png" style="float:right;" />
			And like this with the color renderer:
			<br style="clear:both;" />
			<br />

			<img src="img/plmr2-Res-world-EU-bubble.png" style="float:right;" />
			To look at servers that could'nt be seen because of their size in the Bubble world chart, you can zoom.
			This is zoomed into Europe to make the two servers more visible:
			<br style="clear:both;" />
			<br />
		</div>
		
	<?php
}
?>