<?php
function ex6(){
	if (substr(PHP_VERSION,0,1) < 5){
		echo "Highlighting does not work on this server!";
	}else{
		$gesh = true;
		include_once('../geshi/geshi.php');
		$gpath='../geshi/geshi';
	}

?>
		<h3>Example6: Getting Coral webserver requests</h3>
		
		<div style="margin-left:15px;">
		
			To get the total webserver requests out of a coral node (from the logs) write the following perl script.
			<br />
			Note: you might have to adapt your path (this is mine according to Ex. 5)
		<p>
		<div style="margin-left:15px;">
				
<?php
				$s = '#!/usr/bin/env perl

$path = "/home/utep_1/PLMR/coral-bins/logs/";
$h = `hostname`;
chomp($h);
opendir(DIR,$path);
$c = 0;

while ($f = readdir(DIR)) {
        $f = $path.$f;
        if ( -f $f) {
                open(FILE,$f) || die "Can\'t open file $f: $!";
                while (<FILE>){
                        if (/^3#/) {
                                @s = split(/;/);
                                $c += $s[10];
                        }
                }
                close(FILE);
        }
}
closedir(DIR);
print "($h,$c)";
';
    			if ($gesh) geshi_highlight($s, 'perl', $gpath);
?>
			</div>
			<p>
			It opens every file in the log directory and adds all the total websrv hits up.
			Then it emits the tuple (&lt;hostname&gt;,&lt;hits&gt;).
			
			<br />
			<br />

			If you want just the total not splitted by hostname, get rid of the $h in the above script (reducing the tuple to just the value)
			and supply an aggregation script like the following (in python for a change):
			<p>
			<div style="margin-left:15px;">
				
<?php
				$s = '#!/usr/bin/env python
import sys

f = sys.stdin.readline().rstrip()
first = sys.stdin.read(int(f))
sys.stdin.read(1)
s = sys.stdin.readline().rstrip()
second = sys.stdin.read(int(s))
v = int(first[1:-1]) + int(second[1:-1])
print "(%i)" % v';

    			if ($gesh) geshi_highlight($s, 'python', $gpath);
?>
			</div>
			<p>
			This reads two tuples from stdin and emits the sum to stdout.
			
			
		</div>
		
		<br />
		
		<b>Websrv requests by coordinates</b>
		<div style="margin-left:15px;">
			If you want the requests by coordinates rather than hostname for better plotting on the 2-d map,
			use the technique from Example 4 and write a script that reads the requests as the one above but instead emits the coords with them.
			The following script does the trick:
						<p>
			<div style="margin-left:15px;">
				
<?php
				$s = '#!/usr/bin/env python
import os,sys,urllib2,re

path = "/home/utep_1/PLMR/coral-bins/logs/"
#path = "/Users/derDoc/coral/logs/"
req_str = "http://dlab.robust.cs.utep.edu/~vitus/plmr/allsites.php?hostname="
h = os.popen("hostname").read()
cos = urllib2.urlopen(req_str + h).read()[1:-1]
c = 0

for fn in os.listdir(path):
        fn = os.path.join(path,fn)
        if (os.path.isfile(fn)):
                f = open(fn)
                for line in f.readlines():
                        if re.match("^3#",line):
                                s = line.split(";")
                                c += int(s[10])

print "(%s,%i)" % (cos,c)';
    			if ($gesh) geshi_highlight($s, 'python', $gpath);
?>
			</div>
			<p>
			It uses python do the same as the perl script above, since using LWP in perl was too much if a hassle.
			
		</div>
		<div style="margin-left:15px;">
			<img src="img/ex6-world.png" style="float:right;" />
			The results of running above example and plotting the output in PLMR on a 2d worldmap could look like this:<br />
			(Note: I only made requests against the coral-webproxy running in our node -planetlab1.utep.edu- all others returned 0 hits)
			<br style="clear:both;" />
		</div>
		<br />

<?php
}
?>