<?php
function GUI($u,$p){
if (!$u){
?>

		<h2>GUI:</h2>
		<p style="margin-left:15px;">
			<img src="img/plmr-start.png" style="float:right;" />
			The GUI reflects the design of the script by letting the user select the 3 executables/scripts.
			The first tab selects the IPs to work with, a username for ssh, the method, and a name for the run.
			The last tab displays the results in various formats.
			When started it looks like this:

			<br style="clear:both;" />
			<br />
			The "File" menu allows you to store and later reload a full project including all files, names, and runs.
			It also allows to save the chart as a .PNG file.
			<br />
			The "Runs" menu allows you to delete selected runs and save them as plain text files.
			The "Chart" menu allows you to reset the zoom on the chart and change the run with the category (see <a href="?show=ex3">Example 3</a>).
		</p>
<?php
}else{
	switch($u){
		case 1:
?>
		<h3>IPs:</h3>
		<p style="margin-left:15px;">
			The IPs tab accepts a file or URL in the above line or just IPs typed into the textfield.
			<br />
			<img src="img/plmr-start.png" style="float:right;" />
			<br />
			After a list of IPs has been selected and at least an Init/map file is ready to be transfered, the Run!
			button is selectable.
			
			<br style="clear:both;" />
			<br />
			<img src="img/plmr-IPs-ready.png" style="float:right;" />
			In the following shot the username for ssh is set to our slice name and a name for the run has been selected.
			<br style="clear:both;" />
			
		</p>
<?php
		break;
		case 2:
?>
		<h3>Init/map:</h3>
		<p style="margin-left:15px;">
			<img src="img/PWHN1-Gentab.jpg" width="500" style="float:right;" />
			The Init/Update and Eval tabs are somewhat similar, and look roughly alike the Init tab (now called "Gen", following the 3-in-1 notation):
			The 3-in-1 checkbox marks the selected file as 3-in-1.
			<br style="clear:both;" />
			<br />

			<img src="img/plmr-init-dir.png" style="float:right;" />
			You can either enter a script into the textfield which will get saved and transfered,
			select a file from you harddrive or select a folder.
			The folder takes effect for all 3 tabs and only lets you select a file in that folder:
			<br style="clear:both;" />
		</p>
<?php
		break;
		case 3:
?>
		<h3>Update/reduce:</h3>
		<p style="margin-left:15px;">
			<img src="img/plmr-upd.png" style="float:right;" />
			This is the pristine state of the Update tab:
			<br style="clear:both;" />
			<br />

			<img src="img/plmr-upd-dir.png" style="float:right;" />
			After a dir is selected in the Init tab the update tab turns into this, to let the user select a file:
			<br style="clear:both;" />
		</p>
<?php
		break;
		case 4:
?>
		<h3>Eval:</h3>
		<p style="margin-left:15px;">
			<img src="img/plmr-eval.png" style="float:right;" />
			The eval tab looks like this after startup:
			<br style="clear:both;" />
			<br />
			<img src="img/plmr-eval-dir.png" style="float:right;" />
			The Eval tab also turns into looking like this, to support selecting a file in the folder selected in the init tab:
		</p>
<?php
		break;
		case 5:
			if (!isset($p)){
?>
		<h3>Result:</h3>
		<p style="margin-left:15px;">
			<img src="img/plmr-res.png" style="float:right;" />
			The result tab looks like this after startup:
			<br style="clear:both;" />
			<br />
			<img src="img/plmr-res-box.png" style="float:right;" />
			It has a combobox to let the user select one of different ways of representing the results:
			<br style="clear:both;" />
			<br />
			<img src="img/plmr1-Res-plain.png" style="float:right;" />
			In the normally selected "plain" output the ASCII output is shown:
			<br />
			The Table at the bottom of the window shows all runs, that the user has started and that have returned.
			It lets the user chose some to be displayed in the graphs and also supports deletion.
			Once a run is completed a graph can be displayed.
			<br style="clear:both;" />
			<br>
		</p>

<?php
	}else{
		switch($p){
			case 1:
?>

		<div style="padding-left:15px;">
			There are several types of result sets supported that can be plotted in several ways each:
			<br />
			<br />
		
			<b>(Name&lt;Str&gt;,Y-Val&lt;real&gt;) Tuple</b>
			<div style="padding-left:15px;">
				<img src="img/plmr3-Res-name_bar.png" style="float:right;" />
				Can be plotted as a bar chart, a Line- and an Area-chart.<br>
				This is the Bar-Chart:<br>
				<br style="clear:both;" />
			</div>
			<br>
			<br>
			<b>(X-Val&lt;real&gt;,Y-Val&lt;real&gt;) Tuple</b>
			<div style="padding-left:15px;">
				<img src="img/plmr-Res-xyline.png" style="float:right;" />
				Can be plotted as a bar chart, a Line-, a Dot- and an Area-chart.<br>
				This is the Line-Chart:<br>
				<br style="clear:both;" />
			</div>
			<br>
			<br>
			<b>(X-Val&lt;real&gt;,Y-Val&lt;real&gt;,Z-Val&lt;real&gt;) Tuple</b>
			<div style="padding-left:15px;">
				<img src="img/plmr2-Res-bubble.png" style="float:right;" />
				Can be plotted as a Bubble-Chart where the Dot size represents Z or as a color Dot-Chart where Color represents Z.<br>
				This is the Dot-Chart:<br>
				<br style="clear:both;" />
				<br>
				<img src="img/plmr2-Res-color.png" style="float:right;" />
				And this is the Color-Chart:<br>
				<br style="clear:both;" />
			</div>
				
		</div>
<?php
			break;
			case 2:
?>

			<h3>Chart Preferences:</h3>
			<p style="margin-left:15px;">
				<img src="img/plmr-chartprefs.png" style="float:right;" />
				The chart preferences can be used to set min/max values for both axis as well as their captions.
				It also allows to set a nice background picture.
				<br style="clear:both;" />
				<br />
				
				<img src="img/plmr2-Res-world-bubble.png" style="float:right;" />
				This makes for some really nice charts when used with the XYZ-Bubble and Color Plots.
				This is a color plot of the world with 3 servers (UTEP and 2 in Europe).
				<br>
				Note: the two in Europe are hard to see because of their size.
				<br style="clear:both;" />
				<br />
				<img src="img/plmr2-Res-world-EU-bubble.png" style="float:right;" />
				You can Zoom in to make servers more visible.
				This is zoomed into Europe.<br>
				The Chart menu allows you to reset the zoom, to the min/max values set in the chart-preferences.
		
		<?php
			break;
			case 3:
?>

			<h3>Graphing of PathInfo:</h3>
			<p style="margin-left:15px;">
				<img src="img/plmr08-pi-raw.jpg" width="500" style="float:right;" />
				The collected PathInfo data can be displayed in plain text format:
				<br style="clear:both;" />
				<br />
				
				<img src="img/2d-FTT-screen.jpg" width="500" style="float:right;" />
				It can also be used to display the paths of a query:
				<br>
				This is only an KMR visible.
				
				
				<br style="clear:both;" />
				<br />
				<img src="img/plmr08-pi-2d.jpg" width="500" style="float:right;" />
				This shows both graphs on the same world.
				<br />
				<br style="clear:both;" />
				<br />
				
				The graphs can be saved as pictures, which look like this:
				FTT:
				<img src="img/2d-ftt.jpg" width="800" />
				KMR with 62 nodes:
				<img src="img/2d-KBT-62.jpg" width="800" />
				Another KBT:
				<img src="img/2d-kbt.jpg" width="800" />
				<br />
				<br style="clear:both;" />
				<br />
				
				
				<img src="img/08-KMR-FTT-trees.jpg" width="500" style="float:right;" />
				This information also allows graphing the tree structure of the built tree.
				It would look like this, for the FTT at the top and the KMR at the bottom:
				<br />
				<br style="clear:both;" />
				<br />
				
				These can be saved, too, which look like this:
				
				<img src="img/tree-views.jpg" width="800" />
				<br />
				<br style="clear:both;" />
				<br />
				
<?php
				break;
			}
			}
		break;
		}
	}

}
?>