package utep.pawn;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import java.io.*;
import java.awt.*;
import java.awt.event.ActionEvent;

import org.jfree.chart.plot.PlotOrientation;

public class ChartPrefs implements Serializable {

	private static final long serialVersionUID = 310719801L;

	transient public JDialog theDia;

	transient public File BackgroundImg = null;

	public String BackgroundImgName = null;

	public PlotOrientation PlotOr = PlotOrientation.HORIZONTAL;

	public String Title;

	// X
	public double X_Min;

	public boolean X_Min_changed = false;

	public double X_Max = 1;

	public boolean X_Max_changed = false;

	public double X_Min_Curr;

	public double X_Max_Curr = 1;

	public String X_Capt;

	// Y
	public double Y_Min;

	public boolean Y_Min_changed = false;

	public double Y_Max = 1;

	public boolean Y_Max_changed = false;

	public double Y_Min_Curr;

	public double Y_Max_Curr = 1;

	public String Y_Capt;

	public ChartPrefs() {
		theDia = new JDialog((JFrame) null, "Chart Preferences");
	}

	public void initialize() {
		if (theDia == null)
			theDia = new JDialog((JFrame) null, "Chart Preferences");

		X_Min_changed = false;
		X_Max_changed = false;
		Y_Min_changed = false;
		Y_Max_changed = false;

		// top
		JPanel jptop = new JPanel();
		jptop.add(new JLabel("Plot Orientation"));
		final JComboBox jcc = new JComboBox(new String[] { "Horizontal",
				"Vertical" });
		jcc.setSelectedIndex((PlotOr == PlotOrientation.HORIZONTAL) ? 0 : 1);
		jcc.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (jcc.getSelectedIndex() == 0)
					PlotOr = PlotOrientation.HORIZONTAL;
				else
					PlotOr = PlotOrientation.VERTICAL;
			}
		});
		jptop.add(jcc);
		theDia.getContentPane().add(jptop, BorderLayout.NORTH);

		// center
		JPanel jp = new JPanel(new GridLayout(3, 4));
		// Col Headers (Row1)
		jp.add(new JLabel(""));
		jp.add(new JLabel("Min"));
		jp.add(new JLabel("Max"));
		jp.add(new JLabel("Caption"));
		// Row2
		jp.add(new JLabel("X:"));
		final JTextField jt_xmin = new JTextField(new Double(X_Min).toString(),
				5);
		if (X_Min == Double.NaN)
			jt_xmin.setEditable(false);

		jt_xmin.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				if (jt_xmin.getText().length() > 0) {
					if (jt_xmin.getText().length() == 1
							&& jt_xmin.getText().equals("-"))
						return;
					try {
						X_Min = new Double(jt_xmin.getText()).doubleValue();
						X_Min_changed = true;

					} catch (Exception e) {
						JOptionPane.showMessageDialog(null,
								"Please enter a real value!");
					}
				}
			}
		});
		jp.add(jt_xmin);

		final JTextField jt_xmax = new JTextField(new Double(X_Max).toString(),
				5);
		if (X_Max == Double.NaN)
			jt_xmax.setEditable(false);

		jt_xmax.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				if (jt_xmax.getText().length() > 0) {
					if (jt_xmax.getText().length() == 1
							&& jt_xmax.getText().equals("-"))
						return;
					try {
						X_Max = new Double(jt_xmax.getText()).doubleValue();
						X_Max_changed = true;
					} catch (Exception e) {
						JOptionPane.showMessageDialog(null,
								"Please enter a real value!");
					}
				}
			}
		});
		jp.add(jt_xmax);

		final JTextField jt_xcapt = new JTextField(X_Capt, 10);
		jt_xcapt.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				X_Capt = jt_xcapt.getText();
			}
		});
		jp.add(jt_xcapt);

		// Row3
		jp.add(new JLabel("Y:"));
		final JTextField jt_ymin = new JTextField(new Double(Y_Min).toString(),
				5);
		jt_ymin.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				if (jt_ymin.getText().length() > 0) {
					if (jt_ymin.getText().length() == 1
							&& jt_ymin.getText().equals("-"))
						return;
					try {
						Y_Min = new Double(jt_ymin.getText()).doubleValue();
						Y_Min_changed = true;
					} catch (Exception e) {
						JOptionPane.showMessageDialog(null,
								"Please enter a real value!");
					}
				}
			}
		});
		jp.add(jt_ymin);

		final JTextField jt_ymax = new JTextField(new Double(Y_Max).toString(),
				5);
		jt_ymax.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				if (jt_ymax.getText().length() > 0) {
					if (jt_ymax.getText().length() == 1
							&& jt_ymax.getText().equals("-"))
						return;
					try {
						Y_Max = new Double(jt_ymax.getText()).doubleValue();
						Y_Max_changed = true;
					} catch (Exception e) {
						JOptionPane.showMessageDialog(null,
								"Please enter a real value!");
					}
				}
			}
		});
		jp.add(jt_ymax);

		final JTextField jt_ycapt = new JTextField(Y_Capt, 10);
		jt_ycapt.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				Y_Capt = jt_ycapt.getText();
			}
		});
		jp.add(jt_ycapt);

		theDia.getContentPane().add(jp, BorderLayout.CENTER);

		// bottom
		JPanel jp_bottom = new JPanel();
		JButton jb = new JButton("Background Image");
		jb.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser jfc = new JFileChooser(System
						.getProperty("user.dir"));
				jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
				jfc.setMultiSelectionEnabled(false);
				if (BackgroundImgName != null)
					jfc.setSelectedFile(new File(BackgroundImgName));
				if (JFileChooser.APPROVE_OPTION == jfc.showOpenDialog(null)) {
					BackgroundImg = jfc.getSelectedFile();
					BackgroundImgName = jfc.getSelectedFile().getAbsolutePath();
				}
			}
		});
		jp_bottom.add(new JLabel("Title:"));
		final JTextField jt_tit = new JTextField(Title, 15);
		jt_tit.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				Title = jt_tit.getText();
			}
		});
		jp_bottom.add(jt_tit);
		jp_bottom.add(jb);
		theDia.getContentPane().add(jp_bottom, BorderLayout.SOUTH);
	}

}
