package utep.pawn;

import java.io.*;
import java.util.ArrayList;

public class CmdExecer extends Thread {

	public String cmd;

	public String stdin;

	public String stdout;

	public Object notifyThis;

	public CmdExecer(String c, String in, Object o) {
		cmd = c;
		stdin = in;
		notifyThis = o;
	}

	public void run() {
		try {
			Thread.sleep(0);
			System.out.println(this.getName() + ": execing: '" + cmd + "'");
			if (stdin != null)
				System.out.println(this.getName() + ": with stdin: '" + stdin + "'");

			Process p = Runtime.getRuntime().exec(cmd);
			BufferedWriter out = new BufferedWriter(new OutputStreamWriter(p
					.getOutputStream()));

			if (stdin != null)
				out.write(stdin);
			out.close();

			int exitval = p.waitFor();

			BufferedReader in = new BufferedReader(new InputStreamReader(p
					.getInputStream()));
			String line;
			StringBuffer sb = new StringBuffer();
			while (null != (line = in.readLine()))
				sb.append(line + "\n");
			in.close();

			if (exitval == 0) {
				System.out.println(this.getName() + " code(" + exitval +"): " +sb.toString());
				if (sb.length() > 0)
					this.stdout = sb.toString();
			} else {
				BufferedReader err = new BufferedReader(new InputStreamReader(p
						.getErrorStream()));
				StringBuffer sberr = new StringBuffer();
				
				while (null != (line = err.readLine()))
					sberr.append(line + "\n");
				err.close();
				System.out.println(this.getName() + " code(" + exitval + "):"
						+ sb.toString());
				System.out.println(this.getName() + "err:"
						+ sberr.toString());

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (this.notifyThis != null) {
			synchronized (this.notifyThis) {
				this.notifyThis.notify();
			}
		}
	}
}
