package utep.pawn;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;
//import java.util.*;

import javax.swing.*;
import javax.swing.event.*;

import org.jfree.chart.*;
import org.jfree.chart.labels.StandardXYZToolTipGenerator;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.xy.XYItemRenderer;
import org.jfree.chart.urls.StandardXYZURLGenerator;
import org.jfree.data.category.*;
import org.jfree.data.general.*;
import org.jfree.data.xy.*;
import org.jfree.chart.axis.*;

public class MainWindow {

	// the frame of the window
	public static JFrame myFrame;

	// some defs, #def should really work in Java
	public static final String DefChartTitle = "PWHN Query Results";

	public static final String DefDomText = "Domain";

	public static final String DefRangeText = "Range";

	// the panels for the tabs
	static final JPanel IPPanel = new JPanel(new BorderLayout());

	static final JPanel InitPanel = new JPanel(new BorderLayout());

	static final JPanel UpdaPanel = new JPanel(new BorderLayout());

	static final JPanel EvalPanel = new JPanel(new BorderLayout());

	static final JPanel ResPanel = new JPanel(new BorderLayout());

	// vars for IP (1)
	static JPanel jp1 = new JPanel();

	static JPanel jp1b = new JPanel();

	static JLabel jl1 = new JLabel("File/URL");

	static final JTextField jt1 = new JTextField(20);

	static final JTextArea jta1 = new JTextArea(20, 20);

	static final JButton jb1a = new JButton("Run!");

	static final JButton jb1 = new JButton("Browse/Go");

	static JScrollPane jsp1;

	static final JTextField jt1a = new JTextField("Username");

	static final JComboBox jcc = new JComboBox(new String[] { "flat (script)" });

	static final JProgressBar jpb = new JProgressBar(0, 100);

	static final JTextField jt1b = new JTextField("Name");

	// vars for Init (2)
	static JPanel jp2 = new JPanel();

	static JLabel jl2 = new JLabel("File/Dir to sync");

	static final JTextArea jta2 = new JTextArea(20, 20);

	static final JTextField jt2 = new JTextField(20);

	static JScrollPane jsp2;

	static final JPanel JCenterPanel2 = new JPanel(new BorderLayout());

	static final JPanel JListPane2 = new JPanel();

	static final DefaultListModel listmodel2 = new DefaultListModel();

	static final JList jlist2 = new JList(listmodel2);

	static final JScrollPane listScroller2 = new JScrollPane(jlist2);

	static final JLabel jSelLabel2 = new JLabel("");

	static final JButton jb2 = new JButton("Browse/Go");

	// vars for Agg (3)
	static final JTextField jt3 = new JTextField(20);

	static final JButton jb3 = new JButton("Browse/Go");

	static JPanel jp3 = new JPanel();

	static JLabel jl3 = new JLabel("File to sync");

	static final JTextArea jta3 = new JTextArea(20, 20);

	static JScrollPane jsp3;

	static final JPanel JCenterPanel3 = new JPanel(new BorderLayout());

	static final JPanel JListPane3 = new JPanel();

	static final DefaultListModel listmodel3 = new DefaultListModel();

	static final JList jlist3 = new JList(listmodel3);

	static final JScrollPane listScroller3 = new JScrollPane(jlist3);

	static final JLabel jSelLabel3 = new JLabel("");

	// vars for Eval (4)
	static final JTextField jt4 = new JTextField(20);

	static final JButton jb4 = new JButton("Browse/Go");

	static JPanel jp4 = new JPanel();

	static JLabel jl4 = new JLabel("File");

	static final JTextArea jta4 = new JTextArea(20, 20);

	static JScrollPane jsp4;

	static final JPanel JCenterPanel4 = new JPanel(new BorderLayout());

	static final JPanel JListPane4 = new JPanel();

	static final DefaultListModel listmodel4 = new DefaultListModel();

	static final JList jlist4 = new JList(listmodel4);

	static final JScrollPane listScroller4 = new JScrollPane(jlist4);

	static final JLabel jSelLabel4 = new JLabel("");

	// vars for Results (5)
	static final JTextArea jta5 = new JTextArea(20, 20);

	static final ChartPanel Res_chartPanel = new ChartPanel(null, true);

	static JFreeChart Res_chart;

	static Dataset Res_dataSet; // the currently used dataset

	static final JPanel jp5 = new JPanel(new BorderLayout());

	static final String[] Charts = { "Plain", "(X,Y):Bar", "(X,Y):Line",
			"(X,Y):Dots", "(X,Y):Area", "(X,Y,Z):Dots-Size",
			"(X,Y,Z):Dots-Color", "(Name,Y):Bar", "(Name,Y):Line",
			"(Name,Y):Area" };

	static final JComboBox jcc5 = new JComboBox(Charts);

	static JButton jb_chartprefs = new JButton("Chart Prefs");

	static JPanel jp_res_north = new JPanel();

	static JTable Res_RunTable;

	static JScrollPane Res_RunScrollPane;

	// end vars section

	public MainWindow() {
		makeWindow();
	}

	private static void makeWindow() {

		myFrame = new JFrame("PLMR beta 0.4");
		myFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		myFrame.setSize(610, 410);

		// create Menus
		JMenuBar menuBar = new JMenuBar();
		// File
		JMenu FileMenu = new JMenu("File");
		FileMenu.setMnemonic(KeyEvent.VK_F);
		JMenuItem menuItemLoad = new JMenuItem("Load Project", KeyEvent.VK_L);
		menuItemLoad.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
				ActionEvent.META_MASK));
		menuItemLoad.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				Project p = pawn_main.currProj.LoadFromFile();
				if (p != null) {
					pawn_main.currProj = p;
					pawn_main.currProj.Res_Content.atm = pawn_main.currProj.Res_Content.new myTableModel();
					updateWndFields();
					UpdatePrefs(p.chart_pref);
				}
			}
		});
		FileMenu.add(menuItemLoad);
		JMenuItem menuItemStore = new JMenuItem("Store Project as...", KeyEvent.VK_S);
		menuItemStore.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
				ActionEvent.META_MASK));
		FileMenu.add(menuItemStore);
		menuItemStore.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				pawn_main.currProj.SaveToFile();
			}
		});
		FileMenu.add(new JSeparator());

		JMenuItem menuItemSave = new JMenuItem("Save Chart as pic...",
				KeyEvent.VK_P);
		menuItemSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,
				ActionEvent.META_MASK));
		// FileMenu.add(menuItemSave);
		menuItemSave.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				try {
					Res_chartPanel.doSaveAs();
				} catch (Exception ex) {
					ex.printStackTrace();
				}
			}
		});
		// Edit
		JMenu EditMenu = new JMenu("Runs");
		EditMenu.setMnemonic(KeyEvent.VK_R);

		JMenuItem menuItemDelRun = new JMenuItem("Delete selected Run",
				KeyEvent.VK_D);
		menuItemDelRun.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D,
				ActionEvent.META_MASK));
		menuItemDelRun.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (-1 != Res_RunTable.getSelectedRow())
					pawn_main.currProj.Res_Content.delRun(Res_RunTable
							.getSelectedRow());
			}
		});
		EditMenu.add(menuItemDelRun);
		JMenuItem menuItemStoreDB = new JMenuItem("Store in DB", KeyEvent.VK_S);
		menuItemStoreDB.setEnabled(false);
		// menuItemDelRun.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
		// ActionEvent.META_MASK));
		menuItemStoreDB.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		EditMenu.add(menuItemStoreDB);
		JMenuItem menuItemLoadDB = new JMenuItem("Load from DB", KeyEvent.VK_L);
		menuItemLoadDB.setEnabled(false);
		// menuItemDelRun.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
		// ActionEvent.META_MASK));
		menuItemLoadDB.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		EditMenu.add(menuItemLoadDB);
		JMenuItem menuItemXChart = new JMenuItem("XChange series<->category",
				KeyEvent.VK_X);
		menuItemXChart.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,
				ActionEvent.META_MASK));
		menuItemXChart.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (pawn_main.currProj.Res_Method == 0
						|| (Res_dataSet instanceof DefaultCategoryDataset)) {
					pawn_main.currProj.Res_Content.XChangeSerCat();
					updateChart();
				}
			}
		});
		EditMenu.add(menuItemXChart);

		JMenuItem menuItemSaveRun = new JMenuItem("Save selected Run as...",
				KeyEvent.VK_R);
		menuItemSaveRun.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,
				ActionEvent.META_MASK));
		menuItemSaveRun.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (-1 != Res_RunTable.getSelectedRow()) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc.showSaveDialog(null)) {
						try {
							BufferedWriter bfw = new BufferedWriter(
									new FileWriter(jfc.getSelectedFile()));
							String[] d = pawn_main.currProj.Res_Content
									.getRun(Res_RunTable.getSelectedRow()).Data;
							for (int i = 0; i < d.length; i++)
								bfw.write(d[i] + "\n");
							bfw.close();
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
				}
			}
		});
		EditMenu.add(menuItemSaveRun);

		// Chart menu
		JMenu ChartMenu = new JMenu("Chart");
		EditMenu.setMnemonic(KeyEvent.VK_C);
		ChartMenu.add(menuItemSave);
		JMenuItem menuItemResChart = new JMenuItem("reset Zoom", KeyEvent.VK_Z);
		menuItemResChart.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,
				ActionEvent.META_MASK));
		menuItemResChart.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				ChartPrefs cp = pawn_main.currProj.chart_pref;
				if (pawn_main.currProj.Res_Method == 0)
					return;
				else if (pawn_main.currProj.Res_Method < 7) {
					XYPlot xy = (XYPlot) Res_chart.getPlot();

					ValueAxis va = xy.getDomainAxis();
					va.setLowerBound(cp.X_Min);
					va.setUpperBound(cp.X_Max);
					va = xy.getRangeAxis();
					va.setLowerBound(cp.Y_Min);
					va.setUpperBound(cp.Y_Max);
				} else {
					CategoryPlot xy = (CategoryPlot) Res_chart.getPlot();
					ValueAxis va = xy.getRangeAxis();
					va.setLowerBound(cp.Y_Min);
					va.setUpperBound(cp.Y_Max);
				}
			}
		});
		ChartMenu.add(menuItemResChart);

		// menubar
		menuBar.add(FileMenu);
		menuBar.add(EditMenu);
		menuBar.add(ChartMenu);
		myFrame.setJMenuBar(menuBar);

		/** IP Panel * */

		jp1.add(jl1);
		jp1.add(jt1);

		jta1.setText("#Or enter IPs here, one per line");
		jta1.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				pawn_main.currProj.IP_ScriptContent = jta1.getText();
				pawn_main.currProj.IP_bScriptContent_dirty = true;
				if (jta2.getText().length() > 1
						&& !jta2.getText().equals("#Or enter script here"))
					jb1a.setEnabled(true);
				else
					jb1a.setEnabled(false);

			}
		});
		jsp1 = new JScrollPane(jta1, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		jb1.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt1.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {
						jt1.setText(jfc.getSelectedFile().getPath());
						jb1.doClick();
					}
				} else { // not empty, check contents
					// see if its a URL
					if (jt1.getText().startsWith("http")
							|| jt1.getText().startsWith("www")) {
						try {
							BufferedReader bfr = new BufferedReader(
									new InputStreamReader(
											new URL(jt1.getText()).openStream()));
							jta1.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null)
								jta1.append(line + "\n");
							pawn_main.currProj.IP_bScriptContent_dirty = false;

						} catch (Exception ex) {
							ex.printStackTrace();
						}
					} else {
						// file
						try {
							BufferedReader bfr = new BufferedReader(
									new FileReader(new File(jt1.getText())));
							jta1.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print})*$")) {
									JOptionPane
											.showMessageDialog(myFrame,
													"This needs to be a non-binary file!");
									jt1.setText("");
									return;
								}
								jta1.append(line + "\n");

							}
							pawn_main.currProj.IP_bScriptContent_dirty = false;
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
					// and save
					pawn_main.currProj.IP_File = jt1.getText();
				}
			}
		});
		jp1.add(jb1);
		IPPanel.add(jp1, BorderLayout.NORTH);
		IPPanel.add(jsp1, BorderLayout.CENTER);

		// user field
		jt1a.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				pawn_main.currProj.IP_Username = jt1a.getText();
			}

			public void removeUpdate(DocumentEvent e) {
				pawn_main.currProj.IP_Username = jt1a.getText();
			}

			public void changedUpdate(DocumentEvent e) {
				pawn_main.currProj.IP_Username = jt1a.getText();
			}
		});

		jp1b.add(jt1a);
		// combobox
		jcc.setSelectedIndex(0);
		jcc.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				pawn_main.currProj.IP_Method = jcc.getSelectedIndex();
			}
		});
		jp1b.add(jcc);
		// progressbar
		jpb.setValue(0);
		jpb.setStringPainted(false);
		// jpb.setPreferredSize(new Dimension(400,20));
		jp1b.add(jpb);
		jb1a.setEnabled(false);
		jb1a.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				if (jb1a.getText().equals("Run!")) {
					pawn_main.go(jpb, jt1b.getText());
				} else {
					pawn_main.stop();
				}
			}
		});
		// jp1b.add(jpb);
		jp1b.add(jb1a);
		jp1b.add(new JLabel("as:"));
		jp1b.add(jt1b);

		// and add to box
		IPPanel.add(jp1b, BorderLayout.SOUTH);

		/** Init Panel * */

		jp2.add(jl2);
		jp2.add(jt2);
		// the textarea
		jta2.setText("#Or enter script here");
		jta2.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				Upd();
			}

			public void removeUpdate(DocumentEvent e) {
				Upd();
			}

			public void changedUpdate(DocumentEvent e) {
				Upd();
			}

			private void Upd() {
				pawn_main.currProj.Init_ScriptContent = jta2.getText();
				if (jta1.getText().length() > 1
						&& !jta1.getText().equals(
								"#Or enter IPs here, one per line"))
					jb1a.setEnabled(true);
				else
					jb1a.setEnabled(false);
				pawn_main.currProj.Init_bScriptContent_dirty = true;

			}
		});

		jsp2 = new JScrollPane(jta2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		// make a list in case user selected a dir to sync
		jlist2.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jlist2.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		jlist2.setVisibleRowCount(10);
		listScroller2.setPreferredSize(new Dimension(250, 60));
		jlist2.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting() == false) {

					if (jlist2.getSelectedIndex() == -1) {
						jb1a.setEnabled(false);
					} else {
						// Selection
						pawn_main.currProj.Init_FileInDir = (String) jlist2
								.getSelectedValue();
						if (jta1.getText().length() > 1)
							jb1a.setEnabled(true);

						try {
							File f = new File(jt2.getText() + '/'
									+ (String) jlist2.getSelectedValue());

							BufferedReader bfr = new BufferedReader(
									new FileReader(f));
							jta2.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print}|\\p{Space})*$")) {
									// System.out.println("'"+line+"' does not
									// match");
									jta2.setText("<binary File>");
									break;
								}
								jta2.append(line + "\n");
							}
							pawn_main.currProj.Init_bScriptContent_dirty = false;
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
				}
			}
		});
		//
		JListPane2.add(jSelLabel2);
		JListPane2.add(listScroller2);
		//

		jb2.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt2.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc
							.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {
						jt2.setText(jfc.getSelectedFile().getPath());
						jb2.doClick();
					}

				} else { // not empty, check contents
					// get file
					try {
						File f = new File(jt2.getText());
						if (f.isFile()) {
							jSelLabel2.setText("");
							BufferedReader bfr = new BufferedReader(
									new FileReader(f));
							jta2.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta2.setText("<binary File>");
									break;
								}
								jta2.append(line + "\n");
							}
							pawn_main.currProj.Init_bScriptContent_dirty = false;

							JCenterPanel2.remove(JListPane2);
							pawn_main.currProj.Init_FileIsDir = false;
						} else {// dir
							jSelLabel2.setText("Select Init File:");
							File files[] = f.listFiles();
							listmodel2.clear();
							for (int i = 0; i < files.length; i++)
								if (files[i].isFile())
									listmodel2.addElement(files[i].getName());

							JCenterPanel2.add(JListPane2, BorderLayout.NORTH);
							pawn_main.currProj.Init_FileIsDir = true;
							jt3.setText(jt2.getText());
							jt4.setText(jt2.getText());
							jb3.doClick();
							jb4.doClick();

						}
					} catch (Exception ex) {
						ex.printStackTrace();
					}
					pawn_main.currProj.Init_File = jt2.getText();
				}
			}
		});
		jp2.add(jb2);
		InitPanel.add(jp2, BorderLayout.NORTH);
		JCenterPanel2.add(jsp2, BorderLayout.CENTER);
		InitPanel.add(JCenterPanel2, BorderLayout.CENTER);

		/** Agg Panel * */

		jp3.add(jl3);
		jp3.add(jt3);
		// the textarea
		jta3.setText("#Or enter script here");
		jta3.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				pawn_main.currProj.Upd_ScriptContent = jta3.getText();
				pawn_main.currProj.Upd_bScriptContent_dirty = true;
			}

			public void removeUpdate(DocumentEvent e) {
				pawn_main.currProj.Upd_ScriptContent = jta3.getText();
				pawn_main.currProj.Upd_bScriptContent_dirty = true;
			}

			public void changedUpdate(DocumentEvent e) {
				pawn_main.currProj.Upd_ScriptContent = jta3.getText();
				pawn_main.currProj.Upd_bScriptContent_dirty = true;
			}
		});

		jsp3 = new JScrollPane(jta3, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		// make a list in case user selected a dir to sync

		jlist3.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jlist3.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		jlist3.setVisibleRowCount(10);
		listScroller3.setPreferredSize(new Dimension(250, 60));
		jlist3.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting() == false) {

					if (jlist3.getSelectedIndex() == -1) {
						// No selection, disable fire button.
					} else {
						// Selection
						pawn_main.currProj.Upd_FileInDir = (String) jlist3
								.getSelectedValue();
						try {
							File f = new File(jt3.getText() + '/'
									+ (String) jlist3.getSelectedValue());

							BufferedReader bfr = new BufferedReader(
									new FileReader(f));
							jta3.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta3.setText("<binary File>");
									break;
								}
								jta3.append(line + "\n");
							}
							pawn_main.currProj.Upd_bScriptContent_dirty = false;

						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
				}
			}
		});

		//
		JListPane3.add(jSelLabel3);
		JListPane3.add(listScroller3);
		//
		jb3.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt3.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {

						jt3.setText(jfc.getSelectedFile().getPath());
						jb3.doClick();
					}

				} else { // not empty, check contents
					// get file
					try {
						File f = new File(jt3.getText());
						if (f.isFile()) {
							jSelLabel3.setText("");
							BufferedReader bfr = new BufferedReader(
									new FileReader(f));
							jta3.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta3.setText("<binary File>");
									break;
								}
								jta3.append(line + "\n");
							}
							pawn_main.currProj.Upd_bScriptContent_dirty = false;
							JCenterPanel3.remove(JListPane3);

						} else {// dir
							jSelLabel3.setText("Select Update file:");
							File files[] = f.listFiles();
							listmodel3.clear();
							for (int i = 0; i < files.length; i++)
								if (files[i].isFile())
									listmodel3.addElement(files[i].getName());

							JCenterPanel3.add(JListPane3, BorderLayout.NORTH);

						}
					} catch (Exception ex) {
						ex.printStackTrace();
					}
					pawn_main.currProj.Upd_File = jt3.getText();
				}
			}
		});
		jp3.add(jb3);
		UpdaPanel.add(jp3, BorderLayout.NORTH);
		// UpdaPanel.add(jSelLabel3, BorderLayout.WEST);
		// UpdaPanel.add(jsp3, BorderLayout.CENTER);
		JCenterPanel3.add(jsp3, BorderLayout.CENTER);
		UpdaPanel.add(JCenterPanel3, BorderLayout.CENTER);

		/** And finally the Eval Panel * */

		jp4.add(jl4);
		jp4.add(jt4);
		// the textarea
		jta4.setText("#Or enter script here");
		jta4.getDocument().addDocumentListener(new DocumentListener() {
			public void insertUpdate(DocumentEvent e) {
				pawn_main.currProj.Eval_ScriptContent = jta4.getText();
				pawn_main.currProj.Eval_bScriptContent_dirty = true;
			}

			public void removeUpdate(DocumentEvent e) {
				pawn_main.currProj.Eval_ScriptContent = jta4.getText();
				pawn_main.currProj.Eval_bScriptContent_dirty = true;
			}

			public void changedUpdate(DocumentEvent e) {
				pawn_main.currProj.Eval_ScriptContent = jta4.getText();
				pawn_main.currProj.Eval_bScriptContent_dirty = true;
			}
		});
		jsp4 = new JScrollPane(jta4, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		// make a list in case user selected a dir to sync

		jlist4.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jlist4.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		jlist4.setVisibleRowCount(10);
		listScroller4.setPreferredSize(new Dimension(250, 60));
		jlist4.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting() == false) {

					if (jlist4.getSelectedIndex() == -1) {
						// No selection, disable fire button.
					} else {
						// Selection
						pawn_main.currProj.Eval_FileInDir = (String) jlist4
								.getSelectedValue();
						try {
							File f = new File(jt4.getText() + '/'
									+ (String) jlist4.getSelectedValue());

							BufferedReader bfr = new BufferedReader(
									new FileReader(f));
							jta4.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta4.setText("<binary File>");
									break;
								}
								jta4.append(line + "\n");
							}
							pawn_main.currProj.Eval_bScriptContent_dirty = false;
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
				}
			}
		});

		//
		JListPane4.add(jSelLabel4);
		JListPane4.add(listScroller4);
		//
		jb4.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				// check if textfield empty -> open file chooser
				if (jt4.getText().length() == 0) {
					JFileChooser jfc = new JFileChooser(System
							.getProperty("user.dir"));
					jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
					jfc.setMultiSelectionEnabled(false);
					if (JFileChooser.APPROVE_OPTION == jfc
							.showOpenDialog(myFrame)) {
						jt4.setText(jfc.getSelectedFile().getPath());
						jb4.doClick();
					}

				} else { // not empty, check contents
					// get file
					try {
						File f = new File(jt4.getText());
						if (f.isFile()) {
							jSelLabel4.setText("");
							BufferedReader bfr = new BufferedReader(
									new FileReader(f));
							jta4.setText("");
							String line = null;
							while ((line = bfr.readLine()) != null) {
								if (!line.matches("^(\\p{Print}|\\p{Space})*$")) {
									jta4.setText("<binary File>");
									break;
								}
								jta4.append(line + "\n");
							}
							JCenterPanel4.remove(JListPane4);
							pawn_main.currProj.Eval_bScriptContent_dirty = false;

						} else {// dir
							jSelLabel4.setText("Select eval file:");
							File files[] = f.listFiles();
							listmodel4.clear();
							for (int i = 0; i < files.length; i++)
								if (files[i].isFile())
									listmodel4.addElement(files[i].getName());

							JCenterPanel4.add(JListPane4, BorderLayout.NORTH);

						}
					} catch (Exception ex) {
						ex.printStackTrace();
					}
					pawn_main.currProj.Eval_File = jt3.getText();
				}
			}
		});
		jp4.add(jb4);
		EvalPanel.add(jp4, BorderLayout.NORTH);
		// EvalPanel.add(jSelLabel4, BorderLayout.WEST);
		// EvalPanel.add(jsp4, BorderLayout.CENTER);
		JCenterPanel4.add(jsp4, BorderLayout.CENTER);
		EvalPanel.add(JCenterPanel4, BorderLayout.CENTER);

		/** Results pane * */

		jcc5.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				int sel = jcc5.getSelectedIndex();
				pawn_main.currProj.Res_Method = sel;
				// add textarea if plain
				if (sel == 0) {
					jp5.remove(Res_chartPanel);
					jp5.add(jta5, BorderLayout.CENTER);
					updateChart();

					// or create the chart
				} else if (sel > 0) {
					createChart(sel);
					jp5.remove(jta5);
					jp5.add(Res_chartPanel, BorderLayout.CENTER);
				}
			}
		});
		jcc5.setSelectedIndex(0);

		// create text area for plain output
		jta5.setEditable(false);
		jb_chartprefs.addActionListener(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				show_prefs();
			}
		});

		jp_res_north.add(jcc5);
		jp_res_north.add(jb_chartprefs);
		jp5.add(jp_res_north, BorderLayout.NORTH);
		jp5.add(jta5, BorderLayout.CENTER);

		// make run table, which has RunCollection.atm as its model
		Res_RunTable = new JTable(pawn_main.currProj.Res_Content.atm);
		Res_RunScrollPane = new JScrollPane(Res_RunTable);
		Res_RunTable.setPreferredScrollableViewportSize(new Dimension(300, 50));
		Res_RunTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jp5.add(Res_RunScrollPane, BorderLayout.SOUTH);

		ResPanel.add(jp5, BorderLayout.CENTER);

		/** main tabbed panel * */
		// make the tabbed Pane
		JTabbedPane jtp = new JTabbedPane();
		jtp.addTab("IPs", null, IPPanel, "Select servers");
		jtp.addTab("Init", null, InitPanel, "Init script");
		jtp.addTab("Update", null, UpdaPanel, "Aggregation script");
		jtp.addTab("Eval", null, EvalPanel, "Eval script");
		jtp.addTab("Result", null, ResPanel, "Results");

		myFrame.getContentPane().add(jtp);
		myFrame.pack();
		myFrame.setVisible(true);
	}

	public static void updateWndFields() {
		jta1.setText(pawn_main.currProj.IP_ScriptContent);
		jt1.setText(pawn_main.currProj.IP_File);
		jt1a.setText(pawn_main.currProj.IP_Username);
		jcc.setSelectedIndex(pawn_main.currProj.IP_Method);

		jta2.setText(pawn_main.currProj.Init_ScriptContent);
		jt2.setText(pawn_main.currProj.Init_File);
		if ((pawn_main.currProj.Init_File != null)
				&& !pawn_main.currProj.Init_File.equals(""))
			jb2.doClick();
		jlist2.setSelectedValue(pawn_main.currProj.Init_FileInDir, true);

		jta3.setText(pawn_main.currProj.Upd_ScriptContent);
		jlist3.setSelectedValue(pawn_main.currProj.Upd_FileInDir, true);
		jt3.setText(pawn_main.currProj.Upd_File);

		jta4.setText(pawn_main.currProj.Eval_ScriptContent);
		jlist4.setSelectedValue(pawn_main.currProj.Eval_FileInDir, true);
		jt3.setText(pawn_main.currProj.Eval_File);

		jcc5.setSelectedIndex(pawn_main.currProj.Res_Method);
		Res_RunTable.setModel(pawn_main.currProj.Res_Content.atm);
		pawn_main.currProj.IP_bScriptContent_dirty = false;
		pawn_main.currProj.Init_bScriptContent_dirty = false;
		pawn_main.currProj.Eval_bScriptContent_dirty = false;
		pawn_main.currProj.Upd_bScriptContent_dirty = false;

	}

	private static void createChart(int iType) {
		JFreeChart chart = null;
		// XYSeries series = new XYSeries("Results");
		// Res_dataSet = new XYSeriesCollection(series);
		Res_dataSet = new XYSeriesCollection();

		switch (iType) {

		case 1: // Bar

			chart = ChartFactory.createXYBarChart(DefChartTitle, // title
					DefDomText, // domain axis label
					false, DefRangeText, // range axis label
					new XYBarDataset((XYDataset) Res_dataSet, 0.5), // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);

			break;

		case 2: // Line

			chart = ChartFactory.createXYLineChart(DefChartTitle, // title
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					new XYBarDataset((XYDataset) Res_dataSet, 1), // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);

			break;
		case 3: // Dots
			chart = ChartFactory.createScatterPlot(DefChartTitle, // title
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					new XYBarDataset((XYDataset) Res_dataSet, 1), // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);

			break;

		case 4: // Area
			chart = ChartFactory.createXYAreaChart(DefChartTitle, // title
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					new XYBarDataset((XYDataset) Res_dataSet, 1), // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);

			break;

		case 5: // XYZ Bubble
			Res_dataSet = new XYZSeriesCollection();

			chart = ChartFactory.createBubbleChart(DefChartTitle, // title
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					(XYZDataset) Res_dataSet, // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);

			myXYPlot myPlot = new myXYPlot((XYDataset) Res_dataSet, chart
					.getXYPlot().getDomainAxis(), chart.getXYPlot()
					.getRangeAxis(), chart.getXYPlot().getRenderer());

			myPlot.setOrientation(PlotOrientation.VERTICAL);

			JFreeChart chart2 = new JFreeChart(chart.getTitle().getText(),
					JFreeChart.DEFAULT_TITLE_FONT, myPlot, true);
			chart = chart2;

			break;
		case 6: // XYZ Color
			Res_dataSet = new XYZSeriesCollection();

			chart = ChartFactory.createScatterPlot(DefChartTitle, // title
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					(XYZDataset) Res_dataSet, // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);

			XYItemRenderer renderer = new myLASRenderer(false, true);
			renderer.setBaseToolTipGenerator(new StandardXYZToolTipGenerator());
			renderer.setURLGenerator(new StandardXYZURLGenerator());

			myXYPlot p = new myXYPlot((XYDataset) Res_dataSet, chart
					.getXYPlot().getDomainAxis(), chart.getXYPlot()
					.getRangeAxis(), renderer);
			p.setOrientation(PlotOrientation.VERTICAL);

			JFreeChart c = new JFreeChart(chart.getTitle().getText(),
					JFreeChart.DEFAULT_TITLE_FONT, p, true);
			chart = c;

			break;

		case 7: // Category Bar
			Res_dataSet = new DefaultCategoryDataset();
			chart = ChartFactory.createBarChart(DefChartTitle, // chart
					// title
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					(CategoryDataset) Res_dataSet, // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);
			break;
		case 8: // Category Line
			Res_dataSet = new DefaultCategoryDataset();
			chart = ChartFactory.createLineChart(DefChartTitle, // chart
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					(CategoryDataset) Res_dataSet, // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);
			break;
		case 9: // Category Area
			Res_dataSet = new DefaultCategoryDataset();
			chart = ChartFactory.createAreaChart(DefChartTitle, // chart
					DefDomText, // domain axis label
					DefRangeText, // range axis label
					(CategoryDataset) Res_dataSet, // data
					PlotOrientation.VERTICAL, // orientation
					true, // include legend
					true, // tooltips?
					false // URLs?
					);
			break;
		}
		Res_chart = chart;
		Res_chartPanel.setChart(chart);
		updateChart();
	}

	public static void updateChart() {

		switch (pawn_main.currProj.Res_Method) {

		case 0:
			jta5.setText("");
			for (int i = 0; i < pawn_main.currProj.Res_Content.atm
					.getRowCount(); i++) {
				RunCollection.RunInfo ri = pawn_main.currProj.Res_Content
						.getRun(i);
				if (ri.bVisible) {
					jta5.append(ri.Name + ":\n");
					for (int j = 0; j < ri.Data.length; j++)
						jta5.append(ri.Data[j] + "\n");
					jta5.append("\n");
				}
			}
			break;

		case 1:
		case 2:
		case 3:
		case 4:
			((XYSeriesCollection) Res_dataSet).removeAllSeries();

			// loop over all series
			for (int i = 0; i < pawn_main.currProj.Res_Content.atm
					.getRowCount(); i++) {
				RunCollection.RunInfo ri = pawn_main.currProj.Res_Content
						.getRun(i);
				if (ri.bVisible) {
					XYSeries ds = new XYSeries(ri.Name);

					// and loop over strings in array
					for (int j = 0; j < ri.Data.length; j++) {

						String item = ri.Data[j];
						item = item.substring(1, item.length() - 1);
						String[] items = item.split(",");
						try {
							double x = new Double(items[0]).doubleValue();
							double y = new Double(items[1]).doubleValue();
							ds.add(x, y);
						} catch (Exception e) {
							// e.printStackTrace();
							JOptionPane.showMessageDialog(myFrame,
									"Error converting fields to numbers.");
						}
					}
					((XYSeriesCollection) Res_dataSet).addSeries(ds);
				}
			}

			break;
		case 5:
		case 6:
			((XYZSeriesCollection) Res_dataSet).removeAllSeries();

			// loop over all series
			for (int i = 0; i < pawn_main.currProj.Res_Content.atm
					.getRowCount(); i++) {
				RunCollection.RunInfo ri = pawn_main.currProj.Res_Content
						.getRun(i);
				if (ri.bVisible) {

					XYZSeries xs = new XYZSeries(ri.Name);
					// and loop over strings in array
					for (int j = 0; j < ri.Data.length; j++) {

						String item = ri.Data[j];
						item = item.substring(1, item.length() - 1);
						String[] items = item.split(",");

						try {
							int x = (int) Math.round(new Double(items[0])
									.doubleValue());
							int y = (int) Math.round(new Double(items[1])
									.doubleValue());
							double z = 1;
							if (items.length > 2)
								z = new Double(items[2]).doubleValue();
							xs.add(x, y, z);
						} catch (Exception ex) {
							JOptionPane.showMessageDialog(myFrame,
									"Error converting fields to numbers.");
						}
					}
					((XYZSeriesCollection) Res_dataSet).addSeries(xs);
				}
			}
			break;

		case 7:
		case 8:
		case 9:
			DefaultCategoryDataset cs = ((DefaultCategoryDataset) Res_dataSet);
			cs.clear();

			for (int i = 0; i < pawn_main.currProj.Res_Content.atm
					.getRowCount(); i++) {

				RunCollection.RunInfo ri = pawn_main.currProj.Res_Content
						.getRun(i);
				if (ri.bVisible) {
					String ser = ri.Name;
					// and loop over strings in array
					for (int j = 0; j < ri.Data.length; j++) {
						String item = ri.Data[j];
						item = item.substring(1, item.length() - 1);
						String[] items = item.split(",");
						double y = new Double(items[1]).doubleValue();

						cs.addValue(y, ser, items[0]);
					}
				}
			}
		}
		myFrame.repaint();
		Res_chartPanel.repaint();
	}

	private static void show_prefs() {
		if (pawn_main.currProj.Res_Method > 0) {
			JFreeChart chart = Res_chart;

			ChartPrefs cp = pawn_main.currProj.chart_pref;
			cp.Title = chart.getTitle().getText();

			if (pawn_main.currProj.Res_Method < 7) { // XYPlots
				XYPlot xy = (XYPlot) chart.getPlot();
				cp.PlotOr = xy.getOrientation();

				ValueAxis va = xy.getDomainAxis();
				cp.X_Min_Curr = va.getLowerBound();
				if (cp.X_Min_Curr < cp.X_Min)
					cp.X_Min = cp.X_Min_Curr;
				cp.X_Max_Curr = va.getUpperBound();
				if (cp.X_Max_Curr > cp.X_Max)
					cp.X_Max = cp.X_Max_Curr;
				cp.X_Capt = va.getLabel();

				va = xy.getRangeAxis();
				cp.Y_Min_Curr = va.getLowerBound();
				if (cp.Y_Min_Curr < cp.Y_Min)
					cp.Y_Min = cp.Y_Min_Curr;
				cp.Y_Max_Curr = va.getUpperBound();
				if (cp.Y_Max_Curr > cp.Y_Max)
					cp.Y_Max = cp.Y_Max_Curr;
				cp.Y_Capt = va.getLabel();

			} else { // CatPlots
				CategoryPlot xy = (CategoryPlot) chart.getPlot();
				cp.PlotOr = xy.getOrientation();

				CategoryAxis ca = xy.getDomainAxis();
				cp.X_Min_Curr = Double.NaN;
				cp.X_Max_Curr = Double.NaN;
				cp.X_Capt = ca.getLabel();

				ValueAxis va = xy.getRangeAxis();
				cp.Y_Min_Curr = va.getLowerBound();
				cp.Y_Max_Curr = va.getUpperBound();
				cp.Y_Capt = va.getLabel();
			}

			cp.initialize();
			cp.theDia.pack();
			cp.theDia.setModal(true);
			cp.theDia.setVisible(true);
			UpdatePrefs(cp);
		}
	}

	private static void UpdatePrefs(ChartPrefs cp) {
		if (pawn_main.currProj.Res_Method > 0) {
			JFreeChart chart = Res_chart;

			// and update stuff
			chart.getTitle().setText(cp.Title);
			if (cp.BackgroundImg != null) {
				Image i = Toolkit.getDefaultToolkit().getImage(
						cp.BackgroundImg.getAbsolutePath());
				chart.getPlot().setBackgroundImage(i);
			} else if (cp.BackgroundImgName != null) {
				try {
					Image i = Toolkit.getDefaultToolkit().getImage(
							cp.BackgroundImgName);
					chart.getPlot().setBackgroundImage(i);
				} catch (Exception e) {
				}
			}
			if (pawn_main.currProj.Res_Method < 7) {
				XYPlot xy = (XYPlot) chart.getPlot();
				xy.setOrientation(cp.PlotOr);

				ValueAxis va = xy.getDomainAxis();
				if (cp.X_Min_changed)
					va.setLowerBound(cp.X_Min);
				if (cp.X_Max_changed)
					va.setUpperBound(cp.X_Max);
				va.setLabel(cp.X_Capt);

				va = xy.getRangeAxis();
				if (cp.Y_Min_changed)
					va.setLowerBound(cp.Y_Min);
				if (cp.Y_Max_changed)
					va.setUpperBound(cp.Y_Max);
				va.setLabel(cp.Y_Capt);

			} else {
				CategoryPlot xy = (CategoryPlot) chart.getPlot();
				xy.setOrientation(cp.PlotOr);

				CategoryAxis ca = xy.getDomainAxis();
				ca.setLabel(cp.X_Capt);

				ValueAxis va = xy.getRangeAxis();
				if (cp.Y_Min_changed)
					va.setLowerBound(cp.Y_Min);
				if (cp.Y_Max_changed)
					va.setUpperBound(cp.Y_Max);
				va.setLabel(cp.Y_Capt);
			}
			myFrame.repaint();
			Res_chartPanel.repaint();
		}
	}

}
