package utep.pawn;

import java.io.*;
import java.util.*;
import javax.swing.*;
import java.beans.*;

public final class Project implements Serializable {

	private static final long serialVersionUID = 31071980L;

	//the chartPrefs, if any
	public ChartPrefs chart_pref = new ChartPrefs();
	
	// IP panel vars
	public String IP_File;

	public String IP_ScriptContent;
	
	public boolean IP_bScriptContent_dirty;
	
	public String IP_Username;

	public int IP_Method;
	
	public int IP_Threads;

	// Init panel vars
	public String Init_File;

	public boolean Init_FileIsDir;

	public 	String Init_FileInDir;

	public String Init_ScriptContent;

	public boolean Init_bScriptContent_dirty;

	// Upd
	public String Upd_File;

	public String Upd_FileInDir;

	public String Upd_ScriptContent;

	public boolean Upd_bScriptContent_dirty;

	// Eval
	public String Eval_File;

	public String Eval_FileInDir;

	public String Eval_ScriptContent;

	public boolean Eval_bScriptContent_dirty;

	// Eval
	public int Res_Method;
	//the results of the runs, RunCollection
	public RunCollection Res_Content = new RunCollection();

	
	public Project() {
		/*	
		Res_Content.addRun("PL loads",
					"(2.64333,2.921277,2.91766)\n" +
					"(1.4,5.89,2.1456789)",
				10280l);


		
		
		Res_Content.addRun("PL IPs",
							new String[] {
								"(53,20,1.2)",
								"(112,6,4.5)",
								"(179,18,0.5)",
								"(80,2,6.19)"},
							4l);
		
		Res_Content.addRun("PL vals",
							new String[] {
								"(5,65,6.2)",
								"(128,65,2.8)",
								"(100,56,10.49)",
								"(11,44,8.5)"},
							20l);
*/
								
		Res_Content.addRun("run0",
					"(utep_1,20,1.2)\n"+
					"(utep_2,6,4.5)\n"+
					"(princeton1,18,0.5)\n"+
					"(princeton2,2,6.19)",
				4l);

		Res_Content.addRun("run1",
					"(utep_1,65,6.2)\n"+
					"(utep_2,65,2.8)\n"+
					"(princeton1,56,10.49)\n"+
					"(princeton2,44,8.5)",
				20l);
		
	}

	public void SaveToFile() {
		JFileChooser jfc = new JFileChooser(System.getProperty("user.dir"));
		jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		jfc.setMultiSelectionEnabled(false);
		if (JFileChooser.APPROVE_OPTION == jfc.showSaveDialog(null)) {
			try {
				ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(
						new FileOutputStream(jfc.getSelectedFile())));
				oos.writeObject(this);
				oos.close();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	public Project LoadFromFile() {
		JFileChooser jfc = new JFileChooser(System.getProperty("user.dir"));
		jfc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		jfc.setMultiSelectionEnabled(false);
		Project p = null;
		if (JFileChooser.APPROVE_OPTION == jfc.showOpenDialog(null)) {
			try {
				ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(
						new FileInputStream(jfc.getSelectedFile())));
				p = (Project)ois.readObject();
				ois.close();
				
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		return p;
	}
	
	public String toString() {
		return new String("IP{\n" + "\tFile:" + IP_File + "\n" + "\tScript:"
				+ IP_ScriptContent + "\n" + "\tUser:" + IP_Username + "\n"
				+ "\tMethod:" + IP_Method + "\n" + "}\n" + "Init{\n"
				+ "\tFile:" + Init_File + "\n" + "\tScript:"
				+ Init_ScriptContent + "\n" + "\tDir:" + Init_FileIsDir + "\n"
				+ "\tFInDir:" + Init_FileInDir + "\n" + "}" + "Upd{\n"
				+ "\tFile:" + Upd_File + "\n" + "\tScript:" + Upd_ScriptContent
				+ "\n" + "\tFInDir:" + Upd_FileInDir + "\n" + "}" + "Eval{\n"
				+ "\tFile:" + Eval_File + "\n" + "\tScript:"
				+ Eval_ScriptContent + "\n" + "\tFInDir:" + Eval_FileInDir
				+ "\n" + "}" + "Res{\n" + "\tMeth:" + Res_Method + "\n"
				+ "\tCont:" + Res_Content + "\n" + "}");

	}

}
