package utep.pawn;

import javax.swing.JOptionPane;
import javax.swing.table.*;

import org.jfree.data.category.DefaultCategoryDataset;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.*;

public class RunCollection implements Serializable {

	private static final long serialVersionUID = 310719802L;

	transient public AbstractTableModel atm = new myTableModel();

	private ArrayList Runs = new ArrayList();

	private String[] columnNames = { "show", "Name", "runtime/ms" };

	public RunCollection() {
		// Runs = new ArrayList();
		// atm = new myTableModel();
	}

	public class myTableModel extends AbstractTableModel {

		public myTableModel() {
		}

		public int getRowCount() {
			return Runs.size();
		}

		public int getColumnCount() {
			return columnNames.length;
		}

		public String getColumnName(int col) {
			return columnNames[col];
		}

		public Object getValueAt(int row, int col) {
			RunInfo ri = (RunInfo) Runs.get(row);
			switch (col) {
			case 0:
				return new Boolean(ri.bVisible);
			case 1:
				return ri.Name;
			case 2:
				return new Long(ri.millis);
			}
			return null;
		}

		public void setValueAt(Object value, int row, int col) {
			RunInfo ri = (RunInfo) Runs.get(row);

			switch (col) {
			case 0:
				ri.bVisible = ((Boolean) value).booleanValue();
				break;
			case 1:
				ri.Name = (String) value;
				break;
			case 2:
				ri.millis = ((Long) value).longValue();
				break;
			}
			this.fireTableCellUpdated(row, col);
			MainWindow.updateChart();
			MainWindow.myFrame.repaint();
		}

		public Class getColumnClass(int c) {
			return getValueAt(0, c).getClass();
		}

		public boolean isCellEditable(int row, int col) {
			return (col == 0);
		}

	}

	public int addRun(String n, String d, long s) {
		this.Runs.add(new RunInfo(n, d, s, true));
		atm.fireTableRowsInserted(Runs.size() - 1, Runs.size() - 1);
		if (d != null && null != MainWindow.myFrame) {
			MainWindow.updateChart();
			MainWindow.myFrame.repaint();
		}
		return (this.Runs.size() - 1);
	}

	public void updateRun(int i, String addTo, long s) {
		RunInfo ri = (RunInfo) Runs.get(i);
		if (s > 0)
			ri.millis = s;
		if (addTo != null) {
			ri.Data += addTo;
		}
		atm.fireTableRowsUpdated(i,i);
		if (null != MainWindow.myFrame) {
			MainWindow.updateChart();
			MainWindow.myFrame.repaint();
		}
	}

	public void delRun(int row) {
		this.Runs.remove(row);
		atm.fireTableRowsDeleted(row, row);
		if (null != MainWindow.myFrame) {
			MainWindow.updateChart();
			MainWindow.myFrame.repaint();
		}
	}

	public RunInfo getRun(int i) {
		return (RunInfo) Runs.get(i);
	}

	public RunInfo[] getRuns() {
		return ((RunInfo[]) Runs.toArray(new RunInfo[0]));
	}

	public void XChangeSerCat() {
	
		ArrayList newR = new ArrayList();
		RunInfo[] rs = getRuns();
		String newdata;
		
		// Run's a 3-dim array, so data[0][0] of every run is new name for run
		// outermost loop needs to run over every element of all runs
		try {
			// take size of first run
			String[] d = rs[0].Data.split("\n");
			
			for (int i = 0; i < d.length; i++) {
				// get name of run from run0[i][0]
				String run0item = d[i];
				run0item = run0item.substring(1, run0item.length() - 1);
				String[] run0items = run0item.split(",");
				String run_name = run0items[0];
				
				newdata = "";
				// inner loop needs to run over every ith el. of all runs
				for (int j = 0; j < rs.length; j++) {
					// if current run does not have that element, quit
					String[] jd = rs[j].Data.split("\n");
					if (jd.length <= i) {
						JOptionPane.showMessageDialog(null,
								"Number of elements in Runs do not match");
						return;
					}
					String item = jd[i];
					item = item.substring(1, item.length() - 1);
					String[] items = item.split(",");
					// if name is not the same, exit
					if (!run_name.equals(items[0])) {
						JOptionPane.showMessageDialog(null,
								"Names of elements do not match");
						return;
					}
					// build string for this element from name of run
					String el = ("(" + rs[j].Name + "," + items[1]);
					if (items.length > 2)
						el += "," + items[2];
					el += ")\n";
					newdata += el;
				}
				newR.add(new RunInfo(run_name, newdata, 0, true));
			}
			// and change this.runs
			this.Runs = newR;
			atm.fireTableDataChanged();
		} catch (Exception e) {
			e.printStackTrace();
		}
	
	}

	public class RunInfo implements Serializable {
		private static final long serialVersionUID = 310719803L;

		public String Name;

		public boolean bVisible;

		public String Data = "";

		public long millis;

		public RunInfo(String n, String d, long s, boolean v) {
			this.Name = n;
			if (d != null)
				this.Data = d;
			this.millis = s;
			this.bVisible = v;
		}
	}

	/*
	 * private void writeObject(ObjectOutputStream stream) throws IOException {
	 * stream.writeObject(this.columnNames); stream.writeObject(this.Runs); }
	 */
}
