package utep.pawn;

import java.io.*;
import java.text.DateFormat;
import java.util.*;

import javax.swing.*;

public class Runners {

	public final static int SYNC = 0;

	public final static int EXEC = 1;

	public int method;

	public volatile boolean bRunning;

	public JProgressBar theProgress;

	public String RunName;

	public Thread theR;

	public Runners(int type, JProgressBar jpb, String name) {
		this.theProgress = jpb;
		method = EXEC;
		if (name == null)
			method = SYNC;
		else if (!name.equals("Name"))
			this.RunName = name;
		Runnable r = null;
		switch (type) {
		case 0: // script
			r = new ScriptRunner();
			break;
		case 1: // native
			r = new FlatNativeRunner();
			break;
		}
		theR = new Thread(r);
	}

	public void stop() {
		this.bRunning = false;
		theR.interrupt();
		pwhn.wnd.jb1a.setText("Run!");
		pwhn.wnd.jb1b.setText("Sync");
	}

	public void start() {
		this.bRunning = true;
		theR.start();
	}

	private class ScriptRunner implements Runnable {
		public void run() {
			try {
				theProgress.setIndeterminate(true);
				String cmd = "";
				// System.out.println(cP.toString());
				cmd += "python";
				cmd += " pwhn.py";
				cmd += " -q";
				if (method == SYNC)
					cmd += " -l";
				else if (method == EXEC)
					cmd += " -s";

				cmd += " -t " + pwhn.cP.IP_Threads;

				if (pwhn.cP.IP_Username != null)
					cmd += " -u " + pwhn.cP.IP_Username;

				if (pwhn.cP.IP_File != null)
					cmd += (" -a " + pwhn.cP.IP_File);
				else {
					JOptionPane.showMessageDialog(null,
							"Error, no IP file specified");
					return;
				}

				if (pwhn.cP.Init_FileIsDir) {
					cmd += (" -D " + pwhn.cP.Init_File);
					if (pwhn.cP.Init_FileInDir != null)
						cmd += (" -i " + pwhn.cP.Init_FileInDir);
					if (pwhn.cP.Upd_FileInDir != null)
						cmd += (" -g " + pwhn.cP.Upd_FileInDir);
					if (pwhn.cP.Eval_FileInDir != null)
						cmd += (" -e " + pwhn.cP.Eval_FileInDir);
				} else {
					cmd += (" -i " + pwhn.cP.Init_File);
				}

				System.out.println("Execing: " + cmd);

				Thread.sleep(0);
				long start = System.currentTimeMillis();

				Process p = Runtime.getRuntime().exec(cmd);
				int exitval = p.waitFor();
				long stop = System.currentTimeMillis() - start;

				if (exitval == 0) {
					BufferedReader in = new BufferedReader(
							new InputStreamReader(p.getInputStream()));
					String line;
					StringBuffer sb = new StringBuffer();

					while (null != (line = in.readLine()))
						sb.append(line + "\n");

					if (RunName == null)
						RunName = DateFormat.getDateTimeInstance().format(
								new Date());

					pwhn.cP.Res_Content.addRun(RunName, sb.toString(), stop);
				} else {
					JOptionPane.showMessageDialog(null,
							"Something went wrong, script exited with code "
									+ exitval);
				}

			} catch (Exception e) {
				if (!bRunning)
					e.printStackTrace();
				else
					System.out.println("Stopping...");
			}
			theProgress.setIndeterminate(false);
			pwhn.update();
			pwhn.stop();
		}
	} // end scriptrunner

	private class FlatNativeRunner implements Runnable {
		String user = "";

		boolean bShortcut = false;

		int nt = pwhn.cP.IP_Threads;

		public void run() {
			theProgress.setValue(0);
			String e = null, f = null, g = null;
			List outs;
			String finalin, finalout;
			int runIdx = -1;
			if (RunName == null)
				RunName = DateFormat.getDateTimeInstance().format(new Date());
			if (pwhn.cP.IP_Username != null
					&& !("".equals(pwhn.cP.IP_Username)))
				user = pwhn.cP.IP_Username + "@";

			String[] IPs = pwhn.cP.IP_ScriptContent.split("\n");
			List ips = new ArrayList(IPs.length);
			// build command strings
			for (int i = 0; i < IPs.length; i++)
				if (!IPs[i].startsWith("#"))
					ips.add(IPs[i]);
			IPs = (String[]) ips.toArray(new String[0]);

			long start = System.currentTimeMillis();
			int delta = (Math.round((float) 100 / (float) IPs.length));

			try {
				// get the list of IPs

				if (method == SYNC) {
					String file;
					if (pwhn.cP.Init_FileIsDir) {
						file = pwhn.cP.Init_File;
						if (file.endsWith("/"))
							file = file.substring(0, file.length() - 1);
					} else
						file = pwhn.cP.Init_File;
					sync(IPs, file, delta);
				} else {
					// init
					if ("".equals(pwhn.cP.Init_File))
						return;
					e = new File(pwhn.cP.Init_File).getName();
					if (pwhn.cP.Init_FileIsDir) {
						e = e + "/" + pwhn.cP.Init_FileInDir;
					}
					// script for aggregate
					if (pwhn.cP.Init_FileIsDir) {
						if ((pwhn.cP.Upd_FileInDir != null && !""
								.equals(pwhn.cP.Upd_FileInDir)))
							// f = new File(pwhn.cP.Upd_File).getName() + "/" +
							// pwhn.cP.Upd_FileInDir;
							f = pwhn.cP.Upd_File + "/" + pwhn.cP.Upd_FileInDir;
					} else if (!"".equals(pwhn.cP.Upd_File)) {
						// f = new File(pwhn.cP.Upd_File).getName();
						f = pwhn.cP.Upd_File;
					}

					// script for eval
					if (pwhn.cP.Init_FileIsDir) {
						if ((pwhn.cP.Eval_FileInDir != null && !""
								.equals(pwhn.cP.Eval_FileInDir)))
							// g = new File(pwhn.cP.Eval_File).getName() + "/" +
							// pwhn.cP.Eval_FileInDir;
							g = pwhn.cP.Eval_File + "/"
									+ pwhn.cP.Eval_FileInDir;
					} else if (!"".equals(pwhn.cP.Eval_File)) {
						// g = new File(pwhn.cP.Eval_File).getName();
						g = pwhn.cP.Eval_File;
					}

					runIdx = pwhn.cP.Res_Content.addRun(RunName, null, 0l);

					if ((f == null && g == null)) {
						bShortcut = true;
						exec(IPs, e, runIdx, start, delta);
					} else {
						outs = exec(IPs, e, runIdx, start, delta / 2);
						if (f != null)
							finalin = upd(outs, f, delta / 2);
						else {
							finalin = "";
							for (int i = 0; i < outs.size(); i++) {
								String t = (String) outs.get(i);
								finalin += t.length() + "\n" + t + "\n";
							}
						}
						if (g != null)
							finalout = eval(finalin, g);
						else
							finalout = finalin;

						pwhn.cP.Res_Content.updateRun(runIdx, finalout, 0l);
					}
				}

			} catch (Exception ex) {
				// if (!bRunning)
				ex.printStackTrace();
				// else
				// System.out.println("Stopping...");
			}

			long stop = System.currentTimeMillis() - start;
			if (runIdx > -1)
				pwhn.cP.Res_Content.updateRun(runIdx, null, stop);

			theProgress.setValue(0);
			pwhn.update();
			pwhn.stop();

		}

		private List exec(String[] ips, String file, int rIdx, long start, int D)
				throws Exception {
			List cmds = new ArrayList(ips.length);
			// build command strings
			for (int i = 0; i < ips.length; i++) {
				String p = "ssh " + user + ips[i] + " 'PLMR/" + file + "'";
				cmds.add(p);
			}
			// and loop over cmds
			return loop(cmds, D, rIdx, start);
		}

		private void sync(String[] ips, String file, int D) throws Exception {
			List cmds = new ArrayList(ips.length);
			// build command strings
			for (int i = 0; i < ips.length; i++) {
				String p = "rsync -arz " + file + " " + user + ips[i]
						+ ":~/PLMR/";
				cmds.add(p);
			}
			// and loop over cmds
			loop(cmds, D, -1, 0l);
		}

		private String upd(List l, String f, int D) throws Exception {
			String out = (String) l.remove(0);
			String in, ls;

			while (l.size() > 0) {
				in = "";
				ls = (String) l.remove(0);
				if (out.endsWith("\n"))
					out = out.substring(0, out.length() - 1);
				in += out.length() + "\n" + out + "\n";
				if (ls.endsWith("\n"))
					ls = ls.substring(0, ls.length() - 1);
				in += ls.length() + "\n" + ls + "\n";

				CmdExecer ce = new CmdExecer(f, in, this);
				ce.start();
				try {
					synchronized (this) {
						this.wait();
					}
				} catch (Exception ex) {
					bRunning = false;
					ce.stop();
					throw (ex);
				}
				theProgress.setValue(theProgress.getValue() + D);
				out = ce.stdout;
			}

			return out;
		}

		private String eval(String in, String f) throws Exception {

			CmdExecer ce = new CmdExecer(f, in, this);
			ce.start();
			try {
				synchronized (this) {
					this.wait();
				}
			} catch (Exception ex) {
				bRunning = false;
				ce.stop();
				throw (ex);
			}
			theProgress.setValue(100);
			return ce.stdout;
		}

		private List loop(List cmds, int D, int idx, long s) throws Exception {
			List tList = new ArrayList();
			List oList = new ArrayList();

			try {
				while (bRunning) {

					Iterator it = tList.iterator();
					// and walk over list removing any deads
					while (it.hasNext()) {
						CmdExecer ce = (CmdExecer) it.next();
						if (!ce.isAlive()) {
							if (idx > -1) {
								long now = System.currentTimeMillis() - s;
								pwhn.cP.Res_Content.updateRun(idx,
										((bShortcut) ? ce.stdout : null), now);
							}
							if (ce.stdout != null)
								oList.add(ce.stdout);
							it.remove();
							// and advance the progressbar
							theProgress.setValue(theProgress.getValue() + D);
							
						}
					}
					// and check if there is more to do, and some threads left
					if (cmds.size() == 0 && tList.size() == 0)
						break;

					while ((cmds.size() > 0) && (tList.size() < nt)) {
						String p = (String) cmds.remove(0);
						CmdExecer ce = new CmdExecer(p, null, this);
						ce.start();
						tList.add(ce);
					}
					// wait for any to terminate
					synchronized (this) {
						this.wait();
					}
				}
			} catch (Exception ex) {
				System.out.println("Stopping...");
				// ex.printStackTrace();
				for (int i = 0; i < tList.size(); i++)
					((Thread) (tList.get(i))).stop();
				bRunning = false;
				throw (ex);
			}
			return oList;
		}

	}
}
