package utep.pawn;

import java.io.*;
import java.text.DateFormat;
import java.util.*;

import javax.swing.*;

public class Runners {

	public volatile boolean bRunning;

	public JProgressBar theProgress;

	public String RunName;

	public Thread theR;

	public Runners(int type, JProgressBar jpb, String name) {
		this.theProgress = jpb;
		if (!name.equals("Name"))
			this.RunName = name;
		Runnable r = null;
		switch (type) {
		case 0: // script
			r = new ScriptRunner();
			break;
		}

		theR = new Thread(r);

	}

	public void stop() {
		this.bRunning = false;
		theR.interrupt();
	}

	public void start() {
		this.bRunning = true;
		theR.start();
	}

	private class ScriptRunner implements Runnable {

		public void run() {
			try {
				theProgress.setIndeterminate(true);
				String cmd = "";
				// System.out.println(currProj.toString());
				cmd += "python";
				cmd += " pwhn.py";
				cmd += " -q";
				cmd += " -t 30";

				if (pawn_main.currProj.IP_Username != null)
					cmd += " -u " + pawn_main.currProj.IP_Username;

				if (pawn_main.currProj.IP_File != null)
					cmd += (" -a " + pawn_main.currProj.IP_File);
				else {
					JOptionPane.showMessageDialog(null,
							"Error, no IP file specified");
					return;
				}

				if (pawn_main.currProj.Init_FileIsDir) {
					cmd += (" -D " + pawn_main.currProj.Init_File);
					cmd += (" -i " + pawn_main.currProj.Init_FileInDir);
					if (pawn_main.currProj.Upd_FileInDir != null)
						cmd += (" -g " + pawn_main.currProj.Upd_FileInDir);
					if (pawn_main.currProj.Eval_FileInDir != null)
						cmd += (" -e " + pawn_main.currProj.Eval_FileInDir);
				} else {
					cmd += (" -i " + pawn_main.currProj.Init_File);
				}

				System.out.println("Execing: " + cmd);

				Thread.sleep(0);
				ArrayList ar = new ArrayList();
				long start = System.currentTimeMillis();

				Process p = Runtime.getRuntime().exec(cmd);
				int exitval = p.waitFor();
				long stop = System.currentTimeMillis() - start;

				if (exitval == 0) {
					BufferedReader in = new BufferedReader(
							new InputStreamReader(p.getInputStream()));
					String line = "";

					while (null != (line = in.readLine()))
						ar.add(line);

					if (RunName == null)
						RunName = DateFormat.getDateInstance().format(
								new Date());

					pawn_main.currProj.Res_Content.addRun(RunName,
							((String[]) ar.toArray(new String[0])), stop);
				}else{
					JOptionPane.showMessageDialog(null,
					"Something went wrong, script exited with code "+exitval);
				}

			} catch (InterruptedException ex) {
				System.out.println("Stopping...");
				ex.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
			theProgress.setIndeterminate(false);
			pawn_main.update();
			pawn_main.stop();
		}
	} // end scriptrunner

}
