package utep.pawn.jfree;

import org.jfree.data.Range;
import org.jfree.data.xy.*;


public class XYZSeriesCollection extends XYSeriesCollection implements XYZDataset {

	public XYZSeriesCollection(){
		this(null);
	}
	
	public XYZSeriesCollection(XYZSeries xs){
		super(xs);
	}
	
	public Number getZ(int series, int item) {
        XYZSeries ts = (XYZSeries) this.getSeries(series);
        return ts.getZ(item);
    }

	public double getZValue(int series, int item) {
        XYZSeries ts = (XYZSeries) this.getSeries(series);
        return ts.getZ(item).doubleValue();
    }
	
	public Range findZBounds(){
		double lower = Double.MAX_VALUE;
		double upper = Double.MIN_VALUE;
		for (int i = 0; i < super.getSeriesCount(); i++){
			Range r = ((XYZSeries)super.getSeries(i)).findZBounds();
			
			if ( r.getLowerBound() < lower)
				lower = r.getLowerBound();
			if( r.getUpperBound() > upper)
				upper = r.getUpperBound();
		}
		return new Range(lower,upper);
	}
}
