<?php

function intro(){	
		?>
		<h2>Introduction:</h2>
		
		<p style="margin-left:15px;">
			<b>PlanetLab MapReduce</b> is an implementation of an infrastructure for parallel prefix
			operations on PlanetLab.
			MapReduce is the name of Google's implementation done by the Google Labs.
			<br>
			PLMR was born because we wanted something for application monitoring on PlaneLab.
			It evolved from being application-level monitoring made easy to a full-blown MapReduce and more.
			<br>
			The first running version consisted of a script that basically rsyncs the neccessary files over
			to a list of servers and executes them, both using ssh with vxargs.
			For these scripts to run you need the respective interpreter, of course.
			<br>
			Then I started building a GUI around that script that would represent the results graphically.
			When I wanted to plot points based on their real-world coordinates I realized that the only way to get
			these was to parse sites.xlm.
			I did not want to have to fetch it in every script and parse it, so I wrote a php script to do that, which
			resides on my server.<br>
			This GUI allows to run the script version as well as a more scalable version which builds an aggregation tree upon <a href="http://freepastry.org">FreePastry</a>.
			This version therefore needs a running Java VM (at least 1.4.2) and ssh logins only to start the server.
			<br />
			At the end I realized that I could make a Google Earth Placemark (.KML) reflector out of it,
			since it already had the information from sites.xml parsed into an array.<br>
			So I did.
			<br>
		</p>
		
		<h2>Prefix:</h2>

		<p style="margin-left:15px;">
		
			Prefix Operations in general are operations that are associative (and commonly also commutative) and thus amenable to parallelization
			and ultimately, distribution.
			MapReduce exploits this by distributing the map and the reduce phase.
			The current beta release, however, only distributes the map phase.
		</p>
		
		<h2>PLMR:</h2>
		
		<p style="margin-left:15px;">
			PlanetLab MapReduce essentially works with 3 or less executables (or executable scripts):
		</p>
		<b>Map:</b>
		<p style="margin-left:15px;">
			The <i>map</i> or <i>initializer</i> executable takes whatever input domain it is working with and "maps" it to
			a less dimensional (if it is ASCII data, commonly: tuple-) space.
		</p>	
		<b>Reduce:</b>
		<p style="margin-left:15px;">
			If the <i>reducer</i> or <i>aggregator/updater</i> is given, it will take the outputs of two distinct map runs and aggregate them
			into one output.
		</p>
		<b>Evaluate:</b>
		<p style="margin-left:15px;">
			If the <i>evaluator</i> was given, it will evaluate the last ouput of the aggregator, or all the outputs of
			the map runs, and produce a final answer.
		</p>

	<?php
}
?>